local metadata = {
"## Interface:FS15 1.3",
"## Title: MultiOverlay Hud",
"## Notes: Zeigt Aktuelle Preise/Bestände und vieles mehr in einem PDA Hud an",
"## Author: HappyLooser",
"## Version: 1.5 BETA",
"## Date: 08.04.2015",
"## Update: 08.07.2015",
"## Web: http://www.minetropolis.de/",
"## Info: Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
"## Orginal Link Freigabe:  http://fs-uk.com/ (Mike3650)"
}

MultiOverlay = {};
modDir = g_currentModDirectory;
gameDir = "";

MultiOverlay.timerUpdate = { 
	id = nil;
	delay = 3600000; --1 hours
	updateDay = 0;
	wait = 0;
	first = true;
	interval = 112500; --1.875 min
	warningInterval = 112500; --1.875 min --not active
	isUpdate = false;
};
	
function MultiOverlay:loadMap(name)	
	print("---loading MultiOverlay Hud v1.5 BETA (by HappyLooser)---")	
	gameDir = string.gsub(modDir, "MultiOverlay/", "");
	source(modDir.."scripte/moLoadTables.lua");
	moGuiMiniPDAsetAutoDefaultTableAccepts();	
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_server then
		moDefault.loadHostMp = checkHostPC();
	else
		moDefault.loadHostMp = true;
	end;
	if not moDefault.loadHostMp then
		print("!!!! DETISERVER !!!! Disabled MultiOverlay Hud Features for DetiServer(not Client)")
	end;	
	loadScripts(true);
	loadFirstFillTypesAndStationTriggers(self, false);			
	if table.getn(moFillTypes) > 0 then
		moDefault.loadErrorOrMp = false;
	end;
	if moDefault.loadErrorOrMp then
		print("!!!! WARNING !!!! MultiOverlay have FillTypes Error.... stop Mod MultiOverlay Hud")
		if moDefault.loadHostMp then moDefault.loadHostMp = false;end;
	else				
		g_currentMission.modMultiOverlayUpdate = false;
		--preLoad
		if moDraw == nil then
			moDraw = {};
		end;
		--preLoad
		--upk
		if AAA_UniversalProcessKit ~= nil and AAA_UniversalProcessKit.UniversalProcessKit ~= nil then 
			moDefault.upkMod = true;		
		end;
		--upk
		loadScripts(false);
		moDefault.language = "_".. string.lower(g_languageShort);
		local foundLanguage = false;
		for a=1, table.getn(moLanguage.extern.what) do
			if moLanguage.extern.what[a] == moDefault.language then foundLanguage = true;break;end;
		end;	
		if not foundLanguage then
			moDefault.language = "_en";
		end;
		moSetGetGui:moSetGetGuiLoadTables(self);		
		loadDraws();		
		setAnimalsText(self);
		moDefault.Fillable_NUM_FILLTYPES = Fillable.NUM_FILLTYPES;		
		if loadConfig(self) then
			moSetGetConfigXml:loadSetXmlMiniPDAslots(self);
			moSetGetArtDesign:setMultiOverlayDesign(self, true);			
			moSetGetConfigXml:loadSetNewXmlFruitNames(self);
			moSetGetConfigXml:loadSetNewXmlStationNames(self);
			if MultiOverlay.timerUpdate.interval <= 2000 then MultiOverlay.timerUpdate.interval = 2000;end;
		else
			moSetGetGui:refreshAlignment(self, false, false);
			moGuiMiniPDAsetGet.artDesign = false;
			moSetGetArtDesign:setMultiOverlayDesign(self, false);
		end;
		moSetGetStationes:setStationMaxProPage(self);
		MultiOverlay:steerableLoad(self);
		MultiOverlay.timerUpdate.id = addTimer(1, "MultiOverlay.timerUpdate");		
	end;	
end;

function MultiOverlay:deleteMap()	
	if not moDefault.loadHostMp then
		return;
	end;
	if not moDefault.loadErrorOrMp then
		if not g_currentMission.showHelpText then 
			moDefault.helpText = false;
		else
			moDefault.helpText = true;
		end;
		saveConfig(self);			
		if MultiOverlay.timerUpdate.id ~= nil then
			removeTimer(MultiOverlay.timerUpdate.id)
		end;
		MultiOverlay.timerUpdate.first = true;
		MultiOverlay.timerUpdate.updateDay = 0;
		MultiOverlay.timerUpdate.wait = 0;
		MultiOverlay.timerUpdate.isUpdate = false;
		MultiOverlay.timerUpdate.id = nil;
		moSetGetGui.deleteAllOverlays(self);			
		moDefault.loadErrorOrMp = true;
		moDefault.loadHostMp = false;		
	end;
end;

function MultiOverlay:mouseEvent(posX, posY, isDown, isUp, button)	
	if not moDefault.loadHostMp or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;
	if not moDefault.loadErrorOrMp and moSetGetGui.pdaActive then
		if moSetGetGui.pdaVI.cfg then
			moSetGetKeyMouseEvent:setMouseDisplay(self, posX, posY, isDown, isUp, button);
		else
			moSetGetKeyMouseEvent:setMouse(self, posX, posY, isDown, isUp, button);
		end;		
	elseif not moDefault.loadErrorOrMp and not moSetGetGui.pdaActive then				
		moSetGetKeyMouseEvent:setKey(self, posX, posY, isDown, isUp, button);
		--moSetGetKeyMouseEvent:setMouseCursorDisplay(self, posX, posY, isDown, isUp, button);
		if moDefault.mouseCursorOn then	
			moSetGetKeyMouseEvent:setMouseDisplay(self, posX, posY, isDown, isUp, button);		
		end;		
	end;
end;

function MultiOverlay:keyEvent(unicode, sym, modifier, isDown)	
	if not moDefault.loadHostMp then		
		return;
	end;
	if not moDefault.loadErrorOrMp then
		moSetGetKeyMouseEvent:setKey(self, unicode, sym, modifier, isDown, false);		
	end;	
end;

function MultiOverlay:updateTick(dt)	
end;

function MultiOverlay:update(dt)	
	if not moDefault.loadHostMp then	
		return;
	end;	
	if not moDefault.loadErrorOrMp then		
		if g_currentMission.modMultiOverlayUpdate ~= nil and g_currentMission.modMultiOverlayUpdate then
			g_currentMission.modMultiOverlayUpdate = false;
			firstUpdates(self);
		end;
		if MultiOverlay.timerUpdate.first then			
			firstLoadMapObjects();
			MultiOverlay.timerUpdate.first = false;
			reloadNewFillTypes(self);				
			firstDisplayZoom(self);						
			MultiOverlay.timerUpdate.wait = moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime)*MultiOverlay.timerUpdate.delay;
			MultiOverlay.timerUpdate.updateDay = g_currentMission.environment.currentDay;		
			firstUpdates(self);		
			if zzzz_TriggerExtend ~= nil then			
				if zzzz_TriggerExtend.TriggerExtend.setSellMilk then
					moDefault.triggerExtend = true;			
				end;
			end;
			if ZZZ_courseplay ~= nil then moDefault.coursePlay = true;end;
			if moSetGetGui.pdaVI.cfg then MultiOverlay:steerableLoad(self);end;			
			--testFunction(self);
			--g_currentMission.renderTime = false;
			--g_currentMission.moneyIconOverlay.visible = false;
			--g_currentMission.moneyBackgroundOverlay.visible = false;
			--g_currentMission.moneyTextSize = 0.0;
			--g_currentMission.showHudEnv = false;			
			return;
		end;		
		--if not moSetGetGui.pdaActive and g_currentMission.showHelpText and g_gui.currentGui == nil and not g_currentMission.player.currentTool and not moDefault.coursePlayMouse then
		--	if moDefault.coursePlay and g_currentMission.controlledVehicle then return;end;
		--	local height = g_currentMission.hudHelpTextSize + g_currentMission.hudHelpTextLineSpacing*2;
		--	if moDefault.mouseCursorOn then
				--g_currentMission:addHelpButtonText("MouseCursor Off", InputBinding.MoOnOffMouseCursor);
		--		g_currentMission:addHelpTextFunction(self.drawMouseButtonHelp, self, height, "MouseCursor Off");
		--	else
				--g_currentMission:addHelpButtonText("MouseCursor On", InputBinding.MoOnOffMouseCursor);
		--		g_currentMission:addHelpTextFunction(self.drawMouseButtonHelp, self, height, "MouseCursor On");
		--	end;
		--end;
	end;	
end;

function MultiOverlay:draw()	
	if not moDefault.loadHostMp then		
		return;
	end
	if g_currentMission.ingameMap.isFullSize == true then 
		removePDA(self);
		return true; 
	end;
	--respect settings for other mods(fu Inspector Mod)
	setTextAlignment(false);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods(fu Inspector Mod)	
	if not moDefault.loadErrorOrMp and not moGuiMiniPDAsetGet.refreshImages then		
		if moSetGetGui.pdaActive and not moSetGetGui.pdaVI.cfg then			
			setOpenPage(self);				
		end;		
		if moGuiMiniPDAsetGet.isActive then			
			if moGuiMiniPDAsetGet.slotsActive ~= 0 and moSetGetGui.loadImages.slots then				
				for a=1, moGuiMiniPDAsetGet.slotsActive do
					moSetGetGui["slot".. a]:render();
					--if moGuiMiniPDAsetGet.slotWeather then moSetGetGui["weather1"]:render();end;
					if moSetGetGui.loadImages.warnings then setSlotWarningMiniPDA(self, a);end;
					if string.len(moGuiMiniPDAsetGet.slotNotReadyFound) > 0 then setSlotNotReady(self, a);end;
				end;
				if moGuiMiniPDAsetGet.isKeySwitchActive then moSetGetGui["keySwitch"]:render();end;
				if moGuiMiniPDAsetGet.slotOpen ~= 0 then
					setOpenMiniPDA(self, moGuiMiniPDAsetGet.slot[moGuiMiniPDAsetGet.slotOpen])
				end;					
			end;			
		end;
		if moGuiMiniPDAsetGet.isActiveCfg then
			setOpenMiniPDAcfg(self);
			if moSetGetGui.dragDropMiniPDApos and not moSetGetGui.dragDropSlotOpenMiniPDApos then				
				moSetGetGui["blank"]:render();
			end;
			if moSetGetGui.dragDropSlotOpenMiniPDApos and not moSetGetGui.dragDropMiniPDApos then
				moSetGetGui["newPosRahmen"]:render();
			end;
		end;
		if moSetGetGui.pdaVI.cfg then
			setOpenVIcfg(self);
		end;
	end;
	if not moDefault.loadErrorOrMp and not moGuiMiniPDAsetGet.isActiveCfg and not moSetGetGui.pdaActive and moSetGetGui.pdaVI.on then
		MultiOverlay:setOpenViPDA(self);
	end;
	--for a=1, 8 do
	--	moSetGetGui["weather".. a]:render();
	--end;
	--moSetGetGui["VIlight"]:render();
	--moSetGetGui["VIengine"]:render();	
	--moSetGetGui["test"]:render();	
	--respect settings for other mods
	setTextAlignment(false);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(MultiOverlay);


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function setSlotNotReady(self, slot)	
	local name = moGuiMiniPDAsetGet.slot[slot];	
	local lengthFound = 0;
	local extraCheck = false;
	if name == "placeableTrees" then lengthFound = moDefaultPlaceable.lengthTrees;extraCheck = true;end;
	if name == "placeableMods" then lengthFound = moDefaultPlaceable.lengthMods;extraCheck = true;end;
	if name == "greenHouse" then lengthFound = moDefaultPlaceable.lengthGreenHouse;extraCheck = true;end;
	if name == "placeableObjects" then lengthFound = moDefaultPlaceable.lengthObjects;extraCheck = true;end;
	if not extraCheck then
		if string.find(moGuiMiniPDAsetGet.slotNotReadyFound, name.. " ") then
			moSetGetGui["notReady"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
			moSetGetGui["notReady"]:render();
		end;
	else
		if string.find(moGuiMiniPDAsetGet.slotNotReadyFound, name.. " ") and lengthFound == 0 then
			moSetGetGui["notReady"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
			moSetGetGui["notReady"]:render();
		end;
		if string.find(moGuiMiniPDAsetGet.slotNotReadyFound, name.. " ") and lengthFound > 0 then
			moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, name.. " ", "");
		end;
	end;	
end;

function setOpenVIcfg(self)
	if moSetGetGui.loadImages.miniPDAcfg then
		moDrawVIcfg:setOpenVIcfg(self);
	end;	
end;

function setOpenMiniPDAcfg(self)
	if moSetGetGui.loadImages.miniPDAcfg then
		moSetGetGui["miniPDAcfg"]:render();
		if moGuiMiniPDAsetGet.isActive then
			moSetGetGui["onHudCfg"]:render();
			moDrawCfg:setSlotActiveValues(self);
		else
			moSetGetGui["offHudCfg"]:render();
		end;		
	end;	
end;

function setOpenPage(self)
	if moSetGetGui.loadImages.designs then
		if moSetGetGui.pdaActivePage == 1 then
			moDrawPageDefault:setOpenPage(self);
		elseif moSetGetGui.pdaActivePage == 2 then
			moDrawPageBriefing:setOpenPage(self);
		else
			moDrawPageNext:setOpenPage(self);
		end;					
	end;
end;

function setOpenMiniPDA(self, name)
	local drawName = name;
	if tostring(drawName) == "placeableTrees" or tostring(drawName) == "placeableMods" then drawName = "slots";end;	
	if moDraw[drawName] ~= nil then		
		moDraw[drawName]:setOpenPDA(self, name);
	else
		if tostring(drawName) == "silageSilos" then moDraw["bga"]:setOpenPDA(self);return;end;
		moGuiMiniPDAsetGet.slotOpen = 0;		
		g_currentMission:showBlinkingWarning("not found moDraw.".. tostring(drawName).. ".lua (if error !!)", 2000);		
	end;
end;

function MultiOverlay:setOpenViPDA(self)
	if moSetGetGui.pdaVI.autoPos == 0 then
		if g_currentMission.showHelpText and g_currentMission.hudHelpContentOverlay.y ~= 0 then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removePDA(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.hudHelpContentOverlay.y;
			if g_currentMission.hudHelpTextLineSpacing ~= 0 then moSetGetGui.pdaVI.posY = moSetGetGui.pdaVI.posY - g_currentMission.hudHelpTextLineSpacing*2;end;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removePDA(self);return;end;
			moSetGetGui.pdaVI.posY = 0.994;			
		end;
	elseif moSetGetGui.pdaVI.autoPos == 1 then
		if g_currentMission.ingameMap.isVisible then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removePDA(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.ingameMap.minMapHeight + 0.02;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removePDA(self);return;end;
			moSetGetGui.pdaVI.posY = 0.002;			
		end;
	end;
	if moSetGetGui.pdaVI.iconDesign and not moSetGetGui.loadImages.vi then
		g_currentMission:showBlinkingWarning("not found VI Icons".. tostring("(set TextDesign)"), 2000);
		moSetGetGui.pdaVI.distanceLine = false;
	end;
	if moDraw.vehicles ~= nil then moDraw.vehicles:setOpenPDA(self);end;	
end;

function removePDA(self)
	if moVehicles ~= nil then table.remove(moVehicles);end;	
end;

function MultiOverlay:setMiniPDAupdate(self, name, updateInterval)	
	if not MultiOverlay.timerUpdate.isUpdate or updateInterval then		
		if name == "bestPrice" then setStationUpdate(self);end;
		if name == "greenHouse" then setGreenHouseUpdate(self);end;
		if name == "animals" then setAnimalsUpdate(self);end;
		if name == "fieldsPrice" then setFieldsPriceUpdate(self, false);end;
		if name == "placeableTrees" then setPlaceableTreesUpdate(self);end;
		if name == "placeableObjects" then setPlaceableObjectsUpdate(self);end;
		if name == "placeableMods" then setPlaceableModsUpdate(self);end;
		--if name == "bga" then setBgaUpdate(self);end;
	end;
end;

function setSlotWarningMiniPDA(self, slot)	
	if moGuiMiniPDAsetGet.slotWarning[slot] then
		local name = moGuiMiniPDAsetGet.slot[slot];			
		if string.find(moGuiMiniPDAsetGet.slotWarningOn, name.. " ") and not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, name.. " ") then				
			moDrawWarnings[name](self, slot);			
		end;
	end;	
end;

function setStationUpdate(self, all)
	moSetGetStationes:setStationUpdate(self, all);
end;

function setShopModUpdate(self)
	--moSetGetShopMods:setUpdateShopMod(self);
end;

function setBgaUpdate(self, first)
	if first then 
		moSetGetBga:setFirstBgaUpdate(self);
	else
		moSetGetBga:setBgaUpdate(self);
	end;
end;

function setDemandSalesUpdate(self)
	if not g_currentMission.missionDynamicInfo.isMultiplayer and moDefault.loadDemandPage2 or moDefault.loadDemandPage2Disable and moDefault.loadDemandPage2 then
		moSetGetDemandSales:setDemandSalesUpdate(self);
	end;
end;

function setAnimalsUpdate(self)
	moSetGetAnimals:setAnimalsUpdate(self);
end;

function setGreenHouseUpdate(self)
	moSetGetGreenHouse:setGreenHouseUpdate(self);
end;

function setFieldsPriceUpdate(self, fieldsDef)	
	if fieldsDef then
		moSetGetFields:setFieldsDefination(self);
	else
		moSetGetFields:setFieldsPriceUpdate(self);
	end;
end;

function setPlaceableTreesUpdate(self)
	moSetGetPlaceableTrees:setPlaceableTreesUpdate(self);
end;

function setPlaceableObjectsUpdate(self)
	moSetGetPlaceableObjects:setPlaceableObjectsUpdate(self);
end;

function setPlaceableModsUpdate(self)
	moSetGetPlaceableMods:setPlaceableModsUpdate(self);
end;

function MultiOverlay:setPageUpdate(self)
	if not MultiOverlay.timerUpdate.isUpdate then
		if moSetGetGui.pdaActivePage == 1 then setStationUpdate(self, false);end;
		if moSetGetGui.pdaActivePage == 2 then setDemandSalesUpdate(self);end;
	end;
end;

function setWeatherUpdate(self, first, firstOn)	
	--if firstOn then
	--	g_currentMission.showWeatherForecast = false;
	--	moSetGetGui:refreshAllImages(self);
	--else
	--	moSetGetGui:loadWeatherImages(self, first);
	--end;
end;

function timerUpdate(self)	
	if MultiOverlay.timerUpdate.id == nil then return;end;	
	--if g_currentMission.missionDynamicInfo.isMultiplayer and g_server then
	--	return;
	--end; ---prüfen ob relevant ist	
	if not MultiOverlay.timerUpdate.isUpdate and g_currentMission ~= nil then
		MultiOverlay.timerUpdate.isUpdate = true;
		--if moSetGetGui.pdaActive and moSetGetGui.pdaActivePage == 1 or moSetGetGui.pdaSmallActive then	 
			if MultiOverlay.timerUpdate.updateDay ~= g_currentMission.environment.currentDay then
				MultiOverlay.timerUpdate.updateDay = g_currentMission.environment.currentDay;
				moSetGetConfigXml:saveConfig(self); --hours save
				setStationUpdate(self, true);
				setShopModUpdate(self);
				--if moGuiMiniPDAsetGet.slotWeather then setWeatherUpdate(self, true);end;
			else
				setStationUpdate(self, false);				
			end;
		--end;		
		setDemandSalesUpdate(self);		
		if moGuiMiniPDAsetGet.isActive then
			for a=1, moGuiMiniPDAsetGet.slotsActive do
				local name = moGuiMiniPDAsetGet.slot[moGuiMiniPDAsetGet.slotOpen];
				if moGuiMiniPDAsetGet.slotWarning[a] then
					MultiOverlay:setMiniPDAupdate(self, moGuiMiniPDAsetGet.slot[a], true);
				else					
					if name == "bestPrice" then setStationUpdate(self);end;
					if name == "greenHouse" then setGreenHouseUpdate(self);end;
					if name == "animals" then setAnimalsUpdate(self);end;
					if name == "fieldsPrice" then setFieldsPriceUpdate(self, false);end;
					if name == "placeableTrees" then setPlaceableTreesUpdate(self);end;
					if name == "placeableObjects" then setPlaceableObjectsUpdate(self);end;
					if name == "placeableMods" then setPlaceableModsUpdate(self);end;
					--if name == "bga" then setBgaUpdate(self);end;
				end;
			end;
			
		end;
		MultiOverlay.timerUpdate.isUpdate = false;
		setTimerTime(MultiOverlay.timerUpdate.id, MultiOverlay.timerUpdate.interval);		
		return true;		
	end;
end;

function checkHostPC()
	local path = getUserProfileAppPath();
	local file = path.."/multiOverlaySettings.xml";
	if not fileExists(file) then
		return false;
	end;
	return true;
end;

function reloadNewFillTypes(self)
	if moDefault.Fillable_NUM_FILLTYPES ~= Fillable.NUM_FILLTYPES then
		moSetGetFillTypes:setFirstFillTypes(self, true);
	end;
end;

function loadFirstFillTypesAndStationTriggers(self, updateNewNames)
	moSetGetFillTypes:setFirstFillTypes(self, updateNewNames);
	moSetGetStationes:setFirstStationTriggers(self, updateNewNames);
end;

function firstLoadMapObjects()
	moSetGetMapObjects:searchFirstMapObjects(self);
end;

function firstUpdates(self)
	setStationUpdate(self, true);
	setBgaUpdate(self, true);
	setShopModUpdate(self);
	if moGuiMiniPDAsetGet.isActive then
		moGuiMiniPDAareas:setMiniPDAcfgAreas(self, false);
		for a=1, moGuiMiniPDAsetGet.slotsActive do
			if moGuiMiniPDAsetGet.slot[a] == "greenHouse" then setGreenHouseUpdate(self);end;
			if moGuiMiniPDAsetGet.slot[a] == "animals" then setAnimalsUpdate(self);end;
			if moGuiMiniPDAsetGet.slot[a] == "fieldsPrice" then setFieldsPriceUpdate(self, false);end;
			if moGuiMiniPDAsetGet.slot[a] == "placeableTrees" then setPlaceableTreesUpdate(self);end;
			if moGuiMiniPDAsetGet.slot[a] == "placeableObjects" then setPlaceableObjectsUpdate(self);end;
			--if moGuiMiniPDAsetGet.slot[a] == "weather" then setWeatherUpdate(self, false, true);end;
			if moGuiMiniPDAsetGet.slot[a] == "placeableMods" then setPlaceableModsUpdate(self);end;
		end;
	end;	
	setDemandSalesUpdate(self);
	setFieldsPriceUpdate(self, true);	
	if not moDefault.multiFarm and moDefault.multiFarmSilo > 0 or moDefault.multiFarm and moDefault.multiFarmFound == 0 then moDefault.multiFarmSilo = 0;moDefault.multiFarm = false;end;
end;

function saveConfig(self)
	moSetGetConfigXml:saveConfig(self);
end;

function loadConfig(self)
	return moSetGetConfigXml:loadConfig(self);
end;

function firstDisplayZoom(self)
	if moSetGetGui.adjustZoom then moGuiExtras:setFirstDisplayZoom(self);end;
end;

function setAnimalsText(self)
	moLanguage:setAnimalsTXT(self, moDefault.language);
end;

function MultiOverlay:steerableLoad(self)
  local name = {"vehicle.name." .. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle#type"};
  if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) orgSteerableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknow") 
			end; 
		end; 
	end; 
	if Attachable.load ~= nil then 
		local orgAttachableLoad = Attachable.load 
		Attachable.load = function(self,xmlFile) orgAttachableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknow") 
			end; 
		end; 
	end; 
end;

---coursePlay onFoot
function MultiOverlay.drawMouseButtonHelp(self, posY, txt)
	local xLeft = g_currentMission.hudHelpTextPosX1;
	local xRight = g_currentMission.hudHelpTextPosX2;

	local ovl = moSetGetGui["mouse6"]
	if ovl then
		local y = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*3;
		ovl:setPosition(xLeft - ovl.width*0.2, y);
		ovl:render();
		--xLeft = xLeft + ovl.width*0.6;
	end;

	posY = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*2;
	setTextAlignment(RenderText.ALIGN_RIGHT);
	renderText(xRight, posY, g_currentMission.hudHelpTextSize, txt);

	--setTextAlignment(RenderText.ALIGN_LEFT);
	--renderText(xLeft, posY, g_currentMission.hudHelpTextSize, "Click");
end;
--coursePlay onFoot

function loadDraws()
	source(modDir.."scripte/draw/moDrawPageDefault.lua");
	source(modDir.."scripte/draw/moDrawPageBriefing.lua");
	source(modDir.."scripte/draw/moDrawPageNext.lua");
	source(modDir.."scripte/draw/moDrawGreenHouse.lua");
	source(modDir.."scripte/draw/moDrawAnimals.lua");
	source(modDir.."scripte/draw/moDrawBestPrice.lua");
	source(modDir.."scripte/draw/moDrawAmount.lua");
	source(modDir.."scripte/draw/moDrawFieldsPrice.lua");
	--source(modDir.."scripte/draw/moDrawPlaceableTrees.lua");
	source(modDir.."scripte/draw/moDrawPlaceableObjects.lua");
	source(modDir.."scripte/draw/moDrawCfg.lua");
	source(modDir.."scripte/draw/moDrawWarnings.lua");
	source(modDir.."scripte/draw/moDrawBga.lua");
	source(modDir.."scripte/draw/moDrawVehicles.lua");
	source(modDir.."scripte/draw/moDrawVIcfg.lua");
	source(modDir.."scripte/draw/moDrawSlots.lua");
end;

function loadScripts(first)
	if first then
		source(modDir.."scripte/moSetGetFillTypes.lua");	
		source(modDir.."scripte/moSetGetStationes.lua");
	else
		source(modDir.."scripte/moSetGetInputOutputFillTypes.lua");
		source(modDir.."scripte/moGuiExtras.lua");
		source(modDir.."scripte/moSetGetGui.lua");
		source(modDir.."scripte/moSetGetForeignHuds.lua");
		source(modDir.."scripte/moSetGetAmount.lua");		
		source(modDir.."scripte/moLanguage.lua");	
		source(modDir.."scripte/moSetGetAnimals.lua");
		source(modDir.."scripte/moSetGetGreenHouse.lua");
		source(modDir.."scripte/moSetGetFields.lua");
		source(modDir.."scripte/moSetGetConfigXml.lua");
		source(modDir.."scripte/moSetGetKeyMouseEvent.lua");
		source(modDir.."scripte/moSetGetArtDesign.lua");
		source(modDir.."scripte/moGuiMiniPDAareas.lua");
		source(modDir.."scripte/moSetGetPDAcfg.lua");
		source(modDir.."scripte/moGuiPDAareas.lua");
		source(modDir.."scripte/moSetGetDemandSales.lua");
		source(modDir.."scripte/moSetGetPlaceableTrees.lua");
		source(modDir.."scripte/moSetGetPlaceableObjects.lua");
		source(modDir.."scripte/moSetGetBga.lua");
		--source(modDir.."scripte/moSetGetShopMods.lua");
		source(modDir.."scripte/moSetGetMapObjects.lua");
		source(modDir.."scripte/moSetGetVehicles.lua");
		source(modDir.."scripte/moSetGetPlaceableMods.lua");		
		--source(modDir.."scripte/moSetGetUpk.lua");
	end;
end;

function moGuiMiniPDAsetAutoDefaultTableAccepts()
	--noch schreiben
end;

function testFunction(self)
	--g_i18n:formatNumber(capacity)
	--g_currentMission:addWarning(g_i18n:getText(FruitUtil.fruitIndexToDesc[fruitType].name) .. g_i18n:getText("notAcceptedHere"), 0.018, 0.033);
	--currentPalletFillPercentage    --woolpallet check laut gigant :-(
	--numObjectsInPalletSpawnerTrigger, sheep !
	print("testFunction..............")		
	--noch schreiben	
end;