moSetGetInputOutputFillTypes = {};

function moSetGetInputOutputFillTypes:getTables(self, xmlModString, modType, modName, slotType, category)
	if tostring(modType) == "upk" then return getUpk(self, xmlModString, modName, slotType, category );end;
	if tostring(modType) == "fs" then return getFabrikScript(self, xmlModString, modName, slotType, category);end;
	if tostring(modType) == "ls" then return getLs(self, xmlModString, modName, slotType, category);end;
	if tostring(modType) == "other" then return getOther(self, xmlModString, modName, slotType, category);end;
end;

---upk mods---
function getUpk(self, xmlModString, modName, slotType, category)	
	local moduleList={} -- list of modules used in that mod
	function getChildrenFromModule(module,list)
		if(module.kids~=nil)then
			for _,kid in pairs(module.kids) do
				table.insert(list,kid)
				getChildrenFromModule(kid,list)
			end
		end
	end
	getChildrenFromModule(xmlModString,moduleList)	
	local inputFillTypes = {};
	local outputFillTypes = {};
	local inputFillTypesTemp = {};
	local outputFillTypesTemp = {};
	local containerInput = 1;
	local containerOutput = 1;
	local cancel = false;
	for _,module in pairs(moduleList) do
		if cancel then break;end;
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" and category ~= "stock" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then				
				acceptedFillTypes=module.acceptedFillTypes
			elseif(module.emptyFillTypes~=nil) then -- used in emptytrigger
				acceptedFillTypes=module.emptyFillTypes				
			end
			local wheat_windrow = false;
			local grass_windrow = false;
			local a = 0;
			local foundHeapsFillLevel = true;
			for fillType,isAccepted in pairs(acceptedFillTypes) do				
				a = a+1;
				if cancel then break;end;
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then
						local alreadyInTable=false
						if inputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(inputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, inputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--inputFillTypes[container][1].fillTypeName = fillTypeNameString;
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable) then --and not _windrow and not grass_windrow then
							local info={}
							info.flb=flb
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)							
							if category == "heaps" then
								if info.fillLevel > 0.1 then cancel = true;end;
								if a == table.getn(acceptedFillTypes) and not cancel then foundHeapsFillLevel = false;end;
							end;							
							if inputFillTypesTemp[fillType] == nil or not foundHeapsFillLevel then								
								info.pricePerLiter=module:getRevenuePerLiter(fillType)								
								--if category == "shop" then 
								--	print("shop input.....".. tostring(info.pricePerLiter).. "..filltype..".. tostring(fillType))									
								--end;
								info.name=flb.name							
								info.container = containerInput;																
								info.fillTypeName = "";
								info.heapsFillLevel = false;
								if cancel then info.heapsFillLevel = true;end;
								local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType, category);							
								info.fillTypeName = fillTypeNameString;
								--if pricePerLiter > 0 then info.pricePerLiter = pricePerLiter;end;								
								if not foundHeapsFillLevel then								
									info.fillTypeName = unpack(moLanguage.extern['empty'.. moDefault.language]);
								end;
								if category ~= "heaps" then
									inputFillTypesTemp[fillType] = {};
									table.insert(inputFillTypesTemp[fillType],info)
									containerInput = containerInput+1;
								elseif cancel or not foundHeapsFillLevel then
									cancel = true;
									inputFillTypesTemp[fillType] = {};
									table.insert(inputFillTypesTemp[fillType],info)
									containerInput = containerInput+1;
								end;
							elseif not foundHeapsFillLevel then
								inputFillTypesTemp[fillType][1].capacity = inputFillTypesTemp[fillType][1].capacity+info.capacity;
								inputFillTypesTemp[fillType][1].fillLevel = inputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end
						end;
					end
					--if fillType == wheat_windrow or barley_windrow then wheat_windrow = true;end;
					--if fillType == gras_windrow or dryGrass_windrow then grass_windrow = true;end;						
				end
			end			
		elseif type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" and category ~= "heaps" and category ~= "shop" then
			local fillTypes={}			
			if(module.fillType~=nil) or (module.fillFillType~=nil) then								
				if module.fillFillType ~= nil then
					fillTypes[module.fillFillType] = {};
					fillTypes[module.fillFillType] = true;
				elseif module.fillType ~= nil then					
					fillTypes[module.fillType] = {};
					fillTypes[module.fillType] = true;
				end;	
			elseif(type=="gasstationtrigger") then
				fillTypes[Fillable.FILLTYPE_FUEL] = {};
				fillTypes[Fillable.FILLTYPE_FUEL] = true;				
			elseif(type=="liquidmanurefilltrigger") then
				fillTypes[Fillable.FILLTYPE_LIQUIDMANURE] = {};
				fillTypes[Fillable.FILLTYPE_LIQUIDMANURE] = true;				
			elseif(type=="sprayerfilltrigger") then
				fillTypes[Fillable.FILLTYPE_FERTILIZER] = {};
				fillTypes[Fillable.FILLTYPE_FERTILIZER] = true;				
			elseif(type=="waterfilltrigger") then
				fillTypes[Fillable.FILLTYPE_WATER] = {};
				fillTypes[Fillable.FILLTYPE_WATER] = true;				
			end
			for fillType,isAccepted in pairs(fillTypes) do
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then
						local alreadyInTable=false
						if outputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(outputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, outputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--outputFillTypes[container][1].fillTypeName = fillTypeNameString;	
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable)then
							local info={}
							info.flb=flb							
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)													
							if outputFillTypesTemp[fillType] == nil then
								info.pricePerLiter=module:getPricePerLiter(fillType)								
								info.name=flb.name
								info.container = containerOutput;
								containerOutput = containerOutput+1;								
								outputFillTypesTemp[fillType] = {};
								info.fillTypeName = "";								
								local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType, category);							
								info.fillTypeName = fillTypeNameString;								
								--if pricePerLiter ~= 0 then	info.pricePerLiter = pricePerLiter;end;					
								table.insert(outputFillTypesTemp[fillType], info)
							else
								outputFillTypesTemp[fillType][1].capacity = outputFillTypesTemp[fillType][1].capacity+info.capacity;
								outputFillTypesTemp[fillType][1].fillLevel = outputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end;							
						end
					end
				end
			end			
		end;		
	end;	
	if inputFillTypesTemp ~= nil and category ~= "stock" then
		for _,fillType in pairs(inputFillTypesTemp) do
			local container = fillType[1].container;						
			if inputFillTypes[container] == nil then
				inputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(inputFillTypes[container], info);
			else
				inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+fillType[1].capacity;
				inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				local fillTypeName = inputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;
				else
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;
		end;	
	end;	
	if outputFillTypesTemp ~= nil and not cancel and category ~= "shop" then
		for _,fillType in pairs(outputFillTypesTemp) do
			local container = fillType[1].container;			
			if outputFillTypes[container] == nil then				
				outputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(outputFillTypes[container], info);
			else
				outputFillTypes[container][1].capacity = outputFillTypes[container][1].capacity+fillType[1].capacity;
				outputFillTypes[container][1].fillLevel = outputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				local fillTypeName = outputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;
				else
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;				
		end;			
	end;
	return inputFillTypes, outputFillTypes	
end;

function getFabrikScript(self, xmlModString, modName, slotType, category)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;	
	for _index,v in pairs (xmlModString.Produkte) do
		local fillTypes = {};
		if xmlModString.Produkte[_index].acceptedFillTypes ~= nil then
			fillTypes = xmlModString.Produkte[_index].acceptedFillTypes;
		end;
		for fillType,isAccepted in pairs(fillTypes) do			
			if(isAccepted)then				
				local alreadyInTable=false;
				if outputFillTypes[container] ~= nil then
					--inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+xmlModString.Rohstoffe[_index].capacity;
					--inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+xmlModString.Rohstoffe[_index].fillLevel;					
					local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, outputFillTypes[container][1].fillTypeName, xmlModString.Produkte[_index].nameL, false, slotType, category);
					if not string.find(outputFillTypes[container][1].fillTypeName, fillTypeNameString) then outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;end;
					outputFillTypes[container][1].fillTypeName = fillTypeNameString;
					alreadyInTable=true;					
					break;						
				end;
				if(not alreadyInTable)then
					local info={};
					info.capacity = xmlModString.Produkte[_index].capacity;
					info.fillLevel = xmlModString.Produkte[_index].fillLevel;
					info.container = container;					
					info.fillTypeName = "";
					info.lengthFillTypes = 1;					
					outputFillTypes[container] = {};
					local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, info.fillTypeName, xmlModString.Produkte[_index].nameL, false, slotType, category);					
					info.fillTypeName = fillTypeNameString;
					info.pricePerLiter = pricePerLiter;
					table.insert(outputFillTypes[container], info);					
				end;
			end;
		end;
		container = container+1;
	end;
	container = 1;	
	for _index,v in pairs (xmlModString.Rohstoffe) do
		local acceptedFillTypes = {};
		if xmlModString.Rohstoffe[_index].acceptedFillTypes ~= nil then
			acceptedFillTypes = xmlModString.Rohstoffe[_index].acceptedFillTypes;
		end;
		for fillType,isAccepted in pairs(acceptedFillTypes) do			
			if(isAccepted)then				
				local alreadyInTable=false;
				if inputFillTypes[container] ~= nil then
					--inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+xmlModString.Rohstoffe[_index].capacity;
					--inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+xmlModString.Rohstoffe[_index].fillLevel;					
					local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, inputFillTypes[container][1].fillTypeName, xmlModString.Rohstoffe[_index].nameL, true, slotType, category);
					if not string.find(inputFillTypes[container][1].fillTypeName, fillTypeNameString) then inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;end;
					inputFillTypes[container][1].fillTypeName = fillTypeNameString;
					alreadyInTable=true;					
					break;						
				end;
				if(not alreadyInTable)then
					local info={};
					info.capacity = xmlModString.Rohstoffe[_index].capacity;
					info.fillLevel = xmlModString.Rohstoffe[_index].fillLevel;
					info.container = container;					
					info.fillTypeName = "";
					info.lengthFillTypes = 1;					
					inputFillTypes[container] = {};
					local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, info.fillTypeName, xmlModString.Rohstoffe[_index].nameL, true, slotType, category);					
					info.fillTypeName = fillTypeNameString;
					info.pricePerLiter = pricePerLiter;
					table.insert(inputFillTypes[container], info);					
				end;
			end;
		end;
		container = container+1;
	end;
	return inputFillTypes, outputFillTypes	
end;

function getOther(self, xmlModString, modName, slotType)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	return inputFillTypes, outputFillTypes
end;

function getLs(self, xmlModString, modName, slotType)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	return inputFillTypes, outputFillTypes
end;

function getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName, inputFillTypes, slotType, category)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillType >= 30000 or fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " !".. fillTypeName;									
			else
				stringName = "!".. fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, "unknow") then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. "unknow";									
			else
				stringName = "unknow";
			end;								
		end;	
	end;
	local tableLengthFillName;
	if slotType == "placeableTrees" then tableLengthFillName = moDefault.lengthTreesFillName;end;
	if slotType == "placeableObjects" then tableLengthFillName = moDefault.lengthObjectsFillName;end;
	if slotType == "greenHouse" then tableLengthFillName = moDefault.lengthGreenHouseFillName;end;
	if slotType == "placeableMods" then tableLengthFillName = moDefault.lengthModsFillName;end;
	--if inputFillTypes then
		local nameLength = string.len(fillTypeName)
		if tonumber(nameLength) > 13 and tonumber(tableLengthFillName) < tonumber(nameLength)-13 then tableLengthFillName = tonumber(nameLength)-13;end;
	--end;	
	return pricePerLiter, stringName
end;